"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const node_path_1 = tslib_1.__importDefault(require("node:path"));
const build_1 = require("@angular/build");
const architect_1 = require("@angular-devkit/architect");
const core_1 = require("@angular-devkit/core");
const rxjs_1 = require("rxjs");
const load_module_1 = require("../load-module");
const load_plugins_1 = require("../load-plugins");
function executeBuilder(options, context) {
    const workspaceRoot = (0, core_1.getSystemPath)((0, core_1.normalize)(context.workspaceRoot));
    const tsConfig = node_path_1.default.join(workspaceRoot, options.tsConfig);
    return (0, rxjs_1.defer)(async () => {
        const codePlugins = await (0, load_plugins_1.loadPlugins)(options.plugins, workspaceRoot, tsConfig);
        const indexHtmlTransformer = options.indexHtmlTransformer
            ? await (0, load_module_1.loadModule)(workspaceRoot, options.indexHtmlTransformer, tsConfig)
            : undefined;
        return { codePlugins, indexHtmlTransformer };
    }).pipe((0, rxjs_1.switchMap)((extensions) => {
        return (0, build_1.buildApplication)(options, context, extensions);
    }));
}
exports.default = (0, architect_1.createBuilder)(executeBuilder);
//# sourceMappingURL=index.js.map